unit VisXData_fm_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Visio_TLB;

type
  TForm1 = class(TForm)
    ed_StringToStore: TEdit;
    bt_StringToStream: TButton;
    lb_Result: TLabel;
    bt_StreamToString: TButton;
    bt_Connect: TButton;
    Memo1: TMemo;
    bt_CreateStream: TButton;
    bt_EnumElements: TButton;
    bt_Clear: TButton;
    ed_StreamName: TEdit;
    Label1: TLabel;
    lb_StringReadback: TLabel;
    Label2: TLabel;
    procedure bt_ConnectClick(Sender: TObject);
    procedure bt_StringToStreamClick(Sender: TObject);
    procedure bt_CreateStreamClick(Sender: TObject);
    procedure bt_EnumElementsClick(Sender: TObject);
    procedure bt_StreamToStringClick(Sender: TObject);
    procedure bt_ClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    VisApp: Visio_TLB.Application;
  end;

var
  Form1: TForm1;

implementation
uses comobj, ActiveX, VisXDataLib_TLB;
{$R *.DFM}


//-----------------------------------------------
procedure TForm1.bt_ConnectClick(Sender: TObject);
//-----------------------------------------------
Label skipit;
begin
  VisApp := nil;
  try
    VisApp := GetActiveOleObject('visio.application') as Visio_TLB.Application;
    lb_Result.Caption := 'Connected';
  except
  end;
  If not assigned(VisApp) then
  Begin
    ShowMessage('Couldn''t connect to running Visio instance.');
    goto skipit;
  end;
skipit:
end;

//-----------------------------------------------
procedure TForm1.bt_EnumElementsClick(Sender: TObject);
//-----------------------------------------------
   procedure StatStgToMemo(AStatStg: TStatStg);
   Var
     dwType, grfMode, grfStateBits: DWORD;
     S: string;
   Begin
     S            := AStatStg.pwcsName;
     dwType       := AStatStg.dwType;
     grfMode      := AStatStg.grfMode;
     grfStateBits := AStatStg.grfStateBits;
     S := S + ' Type: '  + IntToHex(dwType, 8)
            + ' Mode: ' + IntToHex(grfMode, 8)
            + ' State: ' + IntToHex(grfStateBits, 8);
     Memo1.Lines.Add(S);
   end;
Var
  AMaster: Visio_TLB.Master;
  AShape : Visio_TLB.Shape ;
  AObject : IUnknown;
  VisXData : VISXDATALib_TLB.VisioExtendedData;
  AStorage, NewStorage : IStorage;
  AEnumStatStg : IEnumSTATSTG;

  AStatStg: TStatStg;
  Flags: integer;
  Count: DWord;
begin
  try
    Memo1.Clear;
    AMaster  := VisApp.ActiveDocument.Masters['VisXData'];
    AShape   := AMaster.Shapes['Visio Extended Data'];
    AObject  := AShape.Object_;
    VisXData := AObject as VISXDATALib_TLB.VisioExtendedData;
    AStorage := VisXData.Storage as IStorage;

    Flags := 0;
    OLECheck(AStorage.Stat(AStatStg, Flags));
    StatStgToMemo(AStatStg);

    OLECheck(AStorage.EnumElements(0, nil,0, AEnumStatStg));
    OLECheck(AEnumStatStg.Next(1, AStatStg, @Count));
    While Count > 0 do
    Begin
      StatStgToMemo(AStatStg);
      OLECheck(AEnumStatStg.Next(1, AStatStg, @Count));
    end;
  except
    On E: exception do ShowMessage('Exception: ' + E.Message);
  end; 
end;


//-----------------------------------------------
procedure TForm1.bt_CreateStreamClick(Sender: TObject);
//-----------------------------------------------
Var
  AMaster: Visio_TLB.Master;
  AShape : Visio_TLB.Shape ;
  AObject : IUnknown;
  VisXData : VISXDATALib_TLB.VisioExtendedData;
  AStorage: IStorage;
  //------------------
  AStream : IStream;
  grfMode: DWORD;
  StreamName: WideString;
  PC: PWideChar;
begin
  try
    StreamName := ed_StreamName.Text;
    AMaster    := VisApp.ActiveDocument.Masters['VisXData'];
    AShape     := AMaster.Shapes['Visio Extended Data'];
    AObject    := AShape.Object_;
    VisXData   := AObject as VISXDATALib_TLB.VisioExtendedData;
    AStorage   := VisXData.Storage as IStorage;
    grfMode    := STGM_SHARE_EXCLUSIVE or STGM_READWRITE;
    PC         := PWideChar(StreamName);
    OLECheck(AStorage.CreateStream(PC, grfMode, 0, 0, AStream));
  except
    On E: exception do ShowMessage('Exception: ' + E.Message);
  end;
end;

//-----------------------------------------------
procedure TForm1.bt_StringToStreamClick(Sender: TObject);
//-----------------------------------------------
Var
  AMaster: Visio_TLB.Master;
  AShape : Visio_TLB.Shape ;
  AObject : IUnknown;
  VisXData : VISXDATALib_TLB.VisioExtendedData;
  AStorage: IStorage;
  //---------------------
  AStream : IStream;
  L : integer;
  grfMode: DWORD;

  S: String;
  PC: PChar;
  StreamName: WideString;
  PWC: PWideChar;
begin
  try
    AMaster  := VisApp.ActiveDocument.Masters['VisXData'];
    AShape   := AMaster.Shapes['Visio Extended Data'];
    AObject  := AShape.Object_;
    VisXData := AObject as VISXDATALib_TLB.VisioExtendedData;
    AStorage := VisXData.Storage as IStorage;

    grfMode  := STGM_SHARE_EXCLUSIVE or STGM_READWRITE;
    StreamName := ed_StreamName.Text;
    PWC        := PWideChar(StreamName);
    OLECheck(AStorage.OpenStream(PWC, nil, grfMode, 0,  AStream));

    S        := ed_StringToStore.Text;
    PC       := PChar(S);
    L        := Length(S) + 1;
    OLECheck(AStream.Write(PC, L, nil));
  except
    On E: exception do ShowMessage('Exception: ' + E.Message);
  end;
end;

//-----------------------------------------------
procedure TForm1.bt_StreamToStringClick(Sender: TObject);
//-----------------------------------------------
Var
  AMaster: Visio_TLB.Master;
  AShape : Visio_TLB.Shape ;
  AObject : IUnknown;
  VisXData : VISXDATALib_TLB.VisioExtendedData;
  AStorage: IStorage;
  //---------------------
  AStream : IStream;
  L : integer;
  grfMode: DWORD;
  PC: PChar;
  ReadCount: LongInt;
  S: string;
  StreamName: WideString;
  PWC: PWideChar;
begin
  try
    AMaster   := VisApp.ActiveDocument.Masters['VisXData'];
    AShape    := AMaster.Shapes['Visio Extended Data'];
    AObject   := AShape.Object_;
    VisXData  := AObject as VISXDATALib_TLB.VisioExtendedData;
    AStorage  := VisXData.Storage as IStorage;

    grfMode   :=  STGM_SHARE_EXCLUSIVE or STGM_READWRITE;
    StreamName := ed_StreamName.Text;
    PWC        := PWideChar(StreamName);
    OLECheck(AStorage.OpenStream(PWC, nil, grfMode, 0,  AStream));

    // OLECheck(
    L := 100;
    S := StringOfChar('x', L + 1);
    PC := PChar(S);
    AStream.Read(PC, L, @ReadCount);
    lb_StringReadback.Caption := PC;
  except
    On E: exception do ShowMessage('Exception: ' + E.Message);
  end;
end;

procedure TForm1.bt_ClearClick(Sender: TObject);
begin
  ed_StreamName.Text        := '';
  ed_StringToStore.Text     := '';
  lb_Result.Caption         := '';
  lb_StringReadback.Caption := '';
  Memo1.Clear;
end;

end.

