VERSION 5.00
Begin VB.Form ES_fm_Events 
   Caption         =   "VBVSL_EventSink"
   ClientHeight    =   5265
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5460
   LinkTopic       =   "Form1"
   ScaleHeight     =   5265
   ScaleWidth      =   5460
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bt_UnhookPageEvents 
      Caption         =   "Unhook Page Cell Events"
      Height          =   495
      Left            =   1320
      TabIndex        =   3
      Top             =   60
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      Height          =   3135
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   720
      Width           =   4575
   End
   Begin VB.CommandButton bt_Clear 
      Caption         =   "Clear"
      Height          =   315
      Left            =   3720
      TabIndex        =   1
      Top             =   60
      Width           =   915
   End
   Begin VB.CommandButton bt_HookPageEvents 
      Caption         =   "Hook Page Cell  Events"
      Height          =   495
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   1155
   End
   Begin VB.Label Label1 
      Caption         =   "1.0"
      Height          =   255
      Left            =   2700
      TabIndex        =   4
      Top             =   120
      Width           =   495
   End
End
Attribute VB_Name = "ES_fm_Events"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents HostWindow As Visio.Window
Attribute HostWindow.VB_VarHelpID = -1
' Dim WithEvents APage As Visio.Page

Dim AEvent As Visio.Event
Dim WithEvents AEventSink As VisEventSink_Forwarder
Attribute AEventSink.VB_VarHelpID = -1

Dim SessionId
Dim LineNum As Long

'---------------------------------
Public Sub InitialFormSettings(ASessionId As Long)
'---------------------------------
Dim AWindow As Visio.Window, S As String, StyleBits As Long

  SessionId = ASessionId
  
  On Error Resume Next
  Set AWindow = Nothing
  Set AWindow = glo.VisioApp.ActiveWindow
  On Error GoTo 0
  
  If AWindow Is Nothing Then
    MsgBox "No active window currently", , "Error"
    GoTo no_win_change
  Else
    StyleBits = WS_CHILD Or WS_VISIBLE
    SetWindowLong& Me.HWnd, GWL_Style, StyleBits
    ' StyleBits = 0
    ' SetWindowLong& Me.HWnd, GWL_ExStyle, StyleBits
    
    Set HostWindow = Nothing
    On Error Resume Next
    S = Caption
    Set HostWindow = AWindow.Windows.Add(S, _
                           visWSVisible, visAnchorBarAddon, 1, 1, 400, 400)
    On Error GoTo 0
    
    If HostWindow Is Nothing Then
      MsgBox "Error adding anchor window: " + S, , "Error"
      GoTo no_win_change
    Else
      SetParent Me.HWnd, HostWindow.WindowHandle32
    End If
    JiggleWindow HostWindow.WindowHandle32
  End If
no_win_change:

End Sub

'---------------------------------
Private Sub Form_Initialize()
'---------------------------------
  Set HostWindow = Nothing
  LineNum = 0
End Sub

'---------------------------------
Private Sub Form_Unload(Cancel As Integer)
'---------------------------------
  ForgetMyObjects
  SendEndSession SessionId
  Set fm_Events = Nothing ' try to force it to go away
End Sub

'---------------------------------
Private Sub Form_Terminate()
'---------------------------------
' Note: don't mention "Me" here or we'll autoinstance another form
 ' MsgBox " Form.Terminate Anchored"
  ForgetMyObjects
  SendTraceMessage "  Form.Terminate for Events window"
End Sub

'---------------------------------
Private Sub ForgetMyObjects()
'---------------------------------
  'Set APage = Nothing
  Set AEvent = Nothing
  Set AEventSink = Nothing
  Set HostWindow = Nothing
End Sub

'---------------------------------
Private Sub Form_Resize()
'---------------------------------
Dim W As Long, H As Long

  W = Me.ScaleWidth
  H = Me.ScaleHeight
  
  If (W > 100) And (H > 100) Then
    Text1.Width = W - 10
    Text1.Height = H - Text1.top - 10
  End If
End Sub


'-------------------------
Private Sub bt_Clear_Click()
'-------------------------
  Text1.Text = ""
End Sub

'---------------------------------
Private Sub bt_HookPageEvents_Click()
'---------------------------------
Dim TempPage As Visio.Page
Dim AEventList As Visio.EventList
Dim EventCode As Integer

  If Not (glo.VisioApp.ActivePage Is Nothing) Then
    ' Set APage = glo.VisioApp.ActivePage
    
    Set TempPage = glo.VisioApp.ActivePage
    Set AEventList = TempPage.EventList
    Set AEventSink = New VisEventSink_Forwarder
    EventCode = visEvtMod + visEvtCell
    Set AEvent = AEventList.AddAdvise(EventCode, AEventSink, "", "")
  End If
End Sub

'---------------------------------
Private Sub bt_UnhookPageEvents_Click()
'---------------------------------
  ' Set APage = Nothing
  Set AEvent = Nothing
  Set AEventSink = Nothing
End Sub

'---------------------------------
Private Sub AEventSink_VisEventProc(ByVal nEventCode As Integer, _
              ByVal pSourceObj As Object, ByVal nEventID As Long, _
              ByVal nEventSeqNum As Long, ByVal pSubjectObj As Object, _
              ByVal vMoreInfo As Variant, ReturnResult As Variant)
'---------------------------------
Dim AShape As Visio.Shape, ACell As Visio.Cell
Dim S As String
  On Error Resume Next
  S = "Blank"
  Set ACell = pSubjectObj
  If Not (ACell Is Nothing) Then
    S = " Cell: " + ACell.Name
    Set AShape = ACell.Shape
    S = "Shape: " + AShape.Name + S
  End If
  AddText S
End Sub

'--------------------------------
Private Sub HostWindow_BeforeWindowClosed(ByVal Window As Visio.IVWindow)
'--------------------------------
  Unload Me
End Sub

'--------------------------------
'Private Sub APage_CellChanged(ByVal Cell As Visio.IVCell)
'--------------------------------
'Dim S As String, AShape As Visio.Shape
'  On Error Resume Next
'    Set AShape = Cell.Shape
'  On Error GoTo 0
'  If Not (AShape Is Nothing) Then S = "Shape: " + AShape.Name + "  "
'  S = S + "Cell Changed: " + Cell.Name
'  AddText S
'End Sub

'--------------------------------
Sub AddText(Msg As String)
'--------------------------------
Dim S As String
  LineNum = LineNum + 1
  S = Text1.Text + vbCrLf + Format(LineNum) + ": " + Msg
  If Len(S) > 15000 Then S = right$(S, 10000)
  Text1.Text = S
  Text1.SelLength = 0
  Text1.SelStart = Len(S) ' so scrolling keeps pace with added text
End Sub
