Attribute VB_Name = "VBVSL_Min_Main"
Option Explicit

'---------------------------------------------------------------------
' VBVSL_Min_Main.BAS module
' Implementation for methods deferred from VBVSL.cls
'
' This implementation may vary widely depending on number,
' size and complexity of AddOns
'----------------------------------------------------------------------

'======================================================================
' Some handy VSL Globals
' Set up as a user-defined type so that IntelliSense will work :-)
'======================================================================
'---------------------------
Public Type VSL_Globals
'---------------------------
  VisioApp As Visio.Application
  VVA_Callback As VBVSL_Types.IVVA_Callback
End Type

Public glo As VSL_Globals

Const OurAddOnIx = 1
Const OurAddonName = "VBVSL_Minimal_AddOn"

'==========================================================
' VSL-level methods
'==========================================================

'------------------------------------
Public Sub VBVSL_Initialize()
'------------------------------------
' Perform any early initialization, but note later opportunity to
' do so when Visio specifically requests to prepare for calls
' in VBVSL_Load and/or VBVSL_

End Sub

'------------------------------------
Public Sub VBVSL_Terminate()
'------------------------------------
' Perform any local cleanup, destroy objects etc. if not already done
' in VBVSL_Unload. At this stage it's too late to talk to Visio.
End Sub

'------------------------------------------------------------------------------------
Public Sub VBVSL_VSLInfo(Descr As String)
'------------------------------------------------------------------------------------
  Descr = "VBVSL_Min VSL"
End Sub

'------------------------------------------------------------------------------------
Public Function VBVSL_Load(ByVal InterfaceVersion As Long) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
' Prepare for RUN calls. Create any objects needed in order to act intelligent.

  VBVSL_Load = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Public Function VBVSL_Unload() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
' Perform any local cleanup, destroy objects etc.

End Function

'------------------------------------------------------------------------------------
Public Function VBVSL_EnumAddOns(ByVal SessionId As Long) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
Dim Attribs As VBVSL_Types.Tvbvsl_AddOnInfo_Attribs
Dim EnableMask As VBVSL_Types.Tvbvsl_AddOnInfo_EnableMask
Dim InvokeOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_InvokeOnMask
Dim NotifyOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_NotifyOnMask

  
  Attribs = vbvsl_ATTS_ISACTION
  EnableMask = vbvsl_ENABLEALWAYS
  InvokeOnMask = vbvsl_INVOKE_DEFAULT
  NotifyOnMask = vbvsl_NOTIFY_DEFAULT
  
  glo.VVA_Callback.RegisterAddOn SessionId, OurAddOnIx, Attribs, EnableMask, _
                             InvokeOnMask, NotifyOnMask, OurAddonName
  
  VBVSL_EnumAddOns = vbvsl_SUCCESS
End Function

'==========================================================
' AddOn-level methods
'==========================================================

'------------------------------------------------------------------------------------
Public Function VBVSL_IsAddOnEnabled(ByVal AddOnIx As Long, _
                ByVal SessionId As Long) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  On Error Resume Next
  
  VBVSL_IsAddOnEnabled = 0        ' 0 = Not Enabled! (ie: doesn't mean success)
  
  If AddOnIx = OurAddOnIx Then
    VBVSL_IsAddOnEnabled = vbvsl_L2V_ENABLED
  End If
End Function

'------------------------------------------------------------------------------------
Public Function VBVSL_Run(ByVal AddOnIx As Long, ByVal SessionId As Long, _
                  ByVal Args As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  On Error Resume Next
  
  If AddOnIx = OurAddOnIx Then
    MsgBox OurAddonName + " Args: " + Args
  End If

End Function

'------------------------------------------------------------------------------------
Public Sub VBVSL_KillSession(ByVal SessionId As Long)
'------------------------------------------------------------------------------------
' End a session for a prior RUN that hasn't ended yet
' not needed if no non-modal form or code
End Sub

'------------------------------------------------------------------------------------
Public Function VBVSL_Test(ByVal I As Long) As Long
'------------------------------------------------------------------------------------
' Test call FROM VVA
  VBVSL_Test = I * 3   ' a simple response
End Function

'====================================================================================
' Some services to other modules in this project
'====================================================================================

'------------------------------------------------------------------------------------
Public Sub SendTraceMessage(Msg As String)
'------------------------------------------------------------------------------------
  On Error Resume Next
  If Not (glo.VVA_Callback Is Nothing) Then
    glo.VVA_Callback.AdapterMessage vbvsl_AdapterMessage_AddMessage, Msg
  End If
End Sub
