VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBVSL_DSS_IAmSel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IVBVSL_AddOn

Const ServiceName = "IAmSel"
Const AddOnName = "VBVSL_DSS_" + ServiceName

'-----------------------------------------
' Service-specific command keywords
'-----------------------------------------
Const kw_SelChanged = "SELCHANGED"
'-----------------------------------------
' Service-specific user row names
'-----------------------------------------
Const rn_IAmSel = "VDSS_IAmSel"
Const cn_IAmSel = "User." + rn_IAmSel

Const rn_SelectList = "VDSS_SelectList"
Const cn_SelectList = "User." + rn_SelectList

'-----------------------------------------
' Event(s) used by this service
'-----------------------------------------
Dim AppSelChangedEvent As Visio.Event

'------------------------------
Private Sub Class_Initialize()
'------------------------------
' nothing
End Sub
'------------------------------
Private Sub Class_Terminate()
'------------------------------
' nothing
End Sub

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_AddOnInfo( _
        Attribs As VBVSL_Types.Tvbvsl_AddOnInfo_Attribs, _
        EnableMask As VBVSL_Types.Tvbvsl_AddOnInfo_EnableMask, _
        InvokeOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_InvokeOnMask, _
        NotifyOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_NotifyOnMask, _
        Name As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  Attribs = vbvsl_ATTS_ISACTION
  EnableMask = vbvsl_ENABLEALWAYS
  InvokeOnMask = vbvsl_INVOKE_DEFAULT
  NotifyOnMask = vbvsl_NOTIFY_DEFAULT
  Name = AddOnName
  
  IVBVSL_AddOn_AddOnInfo = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_IsAddOnEnabled() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  IVBVSL_AddOn_IsAddOnEnabled = vbvsl_L2V_ENABLED
End Function

'------------------------------------------------------------------------------------
Private Sub IVBVSL_AddOn_KillSession(ByVal SessionId As Long)
'------------------------------------------------------------------------------------
  ' nothing
End Sub

'---------------------------------------------------------------------
Private Function IVBVSL_AddOn_Load() As VBVSL_Types.Tvbvsl_ResultCodes
'---------------------------------------------------------------------
  IVBVSL_AddOn_Load = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Run(ByVal SessionId As Long, ByVal ArgStr As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
Dim Args As New VBVSL_ArgHandler, ADoc As Visio.Document, AShape As Visio.Shape
Dim Cmd As String

  IVBVSL_AddOn_Run = vbvsl_SUCCESS
  
  Args.ParseArgs UCase$(ArgStr)
  Cmd = Args.FindValue("cmd")
      
  Select Case UCase$(Cmd)
    Case kw_DocOpened, kw_DocCreated
      Set ADoc = DocFromArgs(Args)
      DocSubscriptionEnforce ADoc, ServiceName
      DocHookupCheck ADoc
     
    Case kw_ShapeDrop
      Set ADoc = DocFromArgs(Args)
      DocSubscriptionEnforce ADoc, ServiceName
      DocHookupCheck ADoc
      
      Set AShape = ShapeFromArgs(Args)
      ShapeSubscriptionEnforce AShape, ServiceName
      
    Case kw_SelChanged
      HandleSelChanged
     
    Case kw_Beep
      Beep
      Beep
  End Select
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Unload() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  ' free objects established by this addon
  Set AppSelChangedEvent = Nothing
  
  IVBVSL_AddOn_Unload = vbvsl_SUCCESS
End Function

'-----------------------------------------------------------
Private Sub DocHookupCheck(ADoc As Visio.Document)
'-----------------------------------------------------------
Dim AEventList As Visio.EventList, AEvent As Visio.Event
Dim EventCode As Integer
  '--------------------------------------------
  ' Standard persistent events to maintain our
  ' service over doc close-open
  '--------------------------------------------
  DocStdPersistentEvents ADoc, AddOnName

  '--------------------------------------------
  ' Any hookups custom for this service
  '--------------------------------------------
  EventCode = visEvtCodeWinSelChange
  If AppSelChangedEvent Is Nothing Then
    Set AEventList = glo.VisioApp.EventList
    Set AppSelChangedEvent = EnsureAOEventExists( _
      AEventList, EventCode, AddOnName, "Cmd=" + kw_SelChanged, False)
  End If
  
End Sub

'================================================
' The actual service itself
'================================================

'------------------------------------------------
Private Sub HandleSelChanged()
'------------------------------------------------
Dim AWin As Visio.Window, ADoc As Visio.Document, APage As Visio.Page
Dim ASel As Visio.Selection, AShape As Visio.Shape
Dim cell_SelectList As Visio.Cell, SelectList As String
Dim cell_IAmSel As Visio.Cell

  On Error Resume Next
    Set AWin = glo.VisioApp.ActiveWindow
    If AWin Is Nothing Then GoTo skipit
    
    Set ASel = AWin.Selection
    If ASel Is Nothing Then GoTo skipit
    
    Set ADoc = AWin.Document
    If ADoc Is Nothing Then GoTo skipit
    
    Set APage = glo.VisioApp.ActivePage
    If APage Is Nothing Then GoTo skipit
  On Error GoTo 0
  
  If Not IsSubscribed(ADoc.DocumentSheet, ServiceName) Then GoTo skipit
  Set cell_SelectList = EnsureUserCellExists(ADoc.DocumentSheet, rn_SelectList)
  If cell_SelectList Is Nothing Then GoTo skipit
  SelectList = TrimQuotes(cell_SelectList.Formula)
  
  UnSelectList ADoc, APage, SelectList
  
  SelectList = ""
  For Each AShape In ASel
    If IsSubscribed(AShape, ServiceName) Then
      Set cell_IAmSel = EnsureUserCellExists(AShape, rn_IAmSel)
      If Not (cell_IAmSel Is Nothing) Then
        cell_IAmSel.Formula = "=1"
        SelectList = SelectList + " " + Format(AShape.Id)
      End If
    End If
  Next AShape
  
  cell_SelectList.Formula = "=""" + Trim(SelectList) + """"
  
skipit:
End Sub

'------------------------------------------------
Private Sub UnSelectList(ADoc As Visio.Document, APage As Visio.Page, SelectList As String)
'------------------------------------------------
Dim S As String, P1 As Integer, P2 As Integer, L As Integer
Dim Id As Integer, SheetId As String
Dim AShape As Visio.Shape, ACell As Visio.Cell

  L = Len(SelectList)
  P1 = 1
  While P1 <= L
    P2 = InStr(P1, SelectList, " ", vbTextCompare)
    If P2 = 0 Then P2 = L + 1 ' where the space "would be"
    S = Mid$(SelectList, P1, P2 - P1)
    Id = Val(S)
    If Id <> 0 Then ' 0 is not a legal shape ID anyway
      SheetId = "Sheet." + Format(Id)
      On Error Resume Next
        Set AShape = APage.Shapes(SheetId)
        If Not (AShape Is Nothing) Then
          Set ACell = AShape.CellsU(cn_IAmSel)
          If Not (ACell Is Nothing) Then
            ACell.Formula = "=0"
          End If
        End If
      On Error GoTo 0
    End If
    P1 = P2 + 1 ' start of next blob
  Wend

End Sub
