VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBVSL_DnD_Show"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'---------------------------------------------------------------------
' VBVSL_DnD_Show
'---------------------------------------------------------------------
Implements IVBVSL_AddOn
Const AddOnName = "VBVSL_DnD_Show"

Public WithEvents HostWindow As Visio.Window
Attribute HostWindow.VB_VarHelpID = -1
Public WithEvents fm_DnD As Tfm_DnD              ' form to go in anchored window
Attribute fm_DnD.VB_VarHelpID = -1
Public WithEvents VisAppWE As Visio.Application  ' overkill for just one event, but easy
Attribute VisAppWE.VB_VarHelpID = -1

Private Sub Class_Initialize()
  ' nothing
End Sub

Private Sub Class_Terminate()
  ' nothing
End Sub



'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_AddOnInfo( _
        Attribs As VBVSL_Types.Tvbvsl_AddOnInfo_Attribs, _
        EnableMask As VBVSL_Types.Tvbvsl_AddOnInfo_EnableMask, _
        InvokeOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_InvokeOnMask, _
        NotifyOnMask As VBVSL_Types.Tvbvsl_AddOnInfo_NotifyOnMask, _
        Name As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  Attribs = vbvsl_ATTS_ISACTION
  EnableMask = vbvsl_ENABLEALWAYS
  InvokeOnMask = vbvsl_INVOKE_DEFAULT
  NotifyOnMask = vbvsl_NOTIFY_DEFAULT
  Name = AddOnName
  
  IVBVSL_AddOn_AddOnInfo = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_IsAddOnEnabled() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  IVBVSL_AddOn_IsAddOnEnabled = vbvsl_L2V_ENABLED
End Function

'------------------------------------------------------------------------------------
Private Sub IVBVSL_AddOn_KillSession(ByVal SessionId As Long)
'------------------------------------------------------------------------------------
  ' nothing
  If Not (fm_DnD Is Nothing) Then
    fm_DnD.List1.OLEDropMode = 0
  End If
  
  CheckHostWindowClosed
End Sub

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Load() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  ' nothing
  IVBVSL_AddOn_Load = vbvsl_SUCCESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Run(ByVal SessionId As Long, ByVal ArgStr As String) As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
Dim Args As VBVSL_ArgHandler, ACmd As String
' for purposes of this demo, assume that user wants a fresh form
' for each call to this addon.  Delete the old one if it's still around

  ' Currently no args needed
  'Set Args = New VBVSL_ArgHandler
  'Args.ParseArgs ArgStr
  'ACmd = Args.FindValue("Cmd")
  
  On Error Resume Next
  
  CheckHostWindowClosed
  Set fm_DnD = New Tfm_DnD
  fm_DnD.Show False
  InitialFormSettings (SessionId)
  
  CheckVisAppWEIsValid

  Set Args = Nothing
  IVBVSL_AddOn_Run = vbvsl_L2V_MODELESS
End Function

'------------------------------------------------------------------------------------
Private Function IVBVSL_AddOn_Unload() As VBVSL_Types.Tvbvsl_ResultCodes
'------------------------------------------------------------------------------------
  On Error Resume Next
  
  ' Unload fm_DnD
  ' Set fm_DnD = Nothing
  
  CheckHostWindowClosed

  IVBVSL_AddOn_Unload = vbvsl_SUCCESS
End Function

'--------------------------------
Private Sub CheckVisAppWEIsValid()
'--------------------------------
  If (VisAppWE Is Nothing) Then
    Set VisAppWE = glo.VisioApp
  End If
End Sub

'--------------------------------
Private Sub CheckHostWindowClosed()
'--------------------------------
  On Error Resume Next
  
  If Not (fm_DnD Is Nothing) Then
    Unload fm_DnD
    Set fm_DnD = Nothing
  End If

  If Not (HostWindow Is Nothing) Then
    HostWindow.Close
  End If
  Set HostWindow = Nothing
End Sub

'---------------------------------
Public Sub InitialFormSettings(ASessionId As Long)
'---------------------------------
Dim AWindow As Visio.Window
Dim S As String, StyleBits As Long

  fm_DnD.SessionId = ASessionId
  
  On Error Resume Next
  Set AWindow = Nothing
  Set AWindow = glo.VisioApp.ActiveWindow
  On Error GoTo 0
  
  If AWindow Is Nothing Then
    MsgBox "No active window currently", , "Error"
    GoTo no_win_change
  Else
    StyleBits = WS_CHILD Or WS_VISIBLE
    SetWindowLong& fm_DnD.HWnd, GWL_Style, StyleBits
    
    Set HostWindow = Nothing
    On Error Resume Next
    Set HostWindow = AWindow.Windows.Add("Added Anchor Window", _
                           visWSVisible, visAnchorBarAddon, 1, 1, 300, 300)
    On Error GoTo 0
    
    If HostWindow Is Nothing Then
      MsgBox "Error adding anchor window: " + S, , "Error"
      GoTo no_win_change
    Else
      SetParent fm_DnD.HWnd, HostWindow.WindowHandle32
    End If
    JiggleWindow HostWindow.WindowHandle32
  End If
no_win_change:
End Sub

'--------------------------------
Private Sub HostWindow_BeforeWindowClosed(ByVal Window As Visio.IVWindow)
'--------------------------------
  SendTraceMessage "  BeforeWindowClosed for Anchored host window."
  Set HostWindow = Nothing
  If Not (fm_DnD Is Nothing) Then
    Unload fm_DnD
    Set fm_DnD = Nothing
  End If
End Sub

'--------------------------------
Private Sub fm_DnD_OnQueryUnload()
'--------------------------------
  Set fm_DnD = Nothing
End Sub

'--------------------------------
Private Function VisAppWE_QueryCancelQuit(ByVal app As Visio.IVApplication) As Boolean
'--------------------------------
' Needed to kill off the Drag-n-drop window and thereby unregister
' the Listbox as an OLE drop target, prior to Visio closing its main window.
' (Note: BeforeQuit event is too late, as is VSL Unload.)
  CheckHostWindowClosed
  Set VisAppWE = Nothing
End Function
